pub mod tim;
use slint::Image;
use tim::TIMInfo;

pub struct Logic {
    unadded_tim: UnaddedTIM,
}

impl Logic {
    pub fn new() -> Logic {
        Logic{unadded_tim: UnaddedTIM::empty()}
    }

    pub fn set_unadded_tim(&mut self, info: TIMInfo, image: Image) {
        self.unadded_tim = UnaddedTIM::new(info, image);
    }

    pub fn add_unadded_tim_as(&mut self, _name: &String) -> Image {
        let _info = self.unadded_tim.take_info();
        self.unadded_tim.take_image()
    }
}

struct UnaddedTIM {
    info:  TIMInfo,
    image: Image,
}

impl UnaddedTIM {
    pub fn new(info: TIMInfo, image: Image) -> UnaddedTIM {
        UnaddedTIM{info, image}
    }

    pub fn take_info(&mut self) -> TIMInfo {
        std::mem::take(&mut self.info)
    }

    pub fn take_image(&mut self) -> Image {
        std::mem::take(&mut self.image)
    }

    fn empty() -> UnaddedTIM {
        UnaddedTIM{info: TIMInfo{}, image: Image::default()}
    }
}